//
// 	File:        primarray.h
// 	Date:        30-Jul-95
//	Description: array template for primitive types
//

#ifndef PRIMARRAY_H
#define PRIMARRAY_H

#ifndef assert
#include <assert.h>
#endif

#ifndef NULL
#define NULL 0
#endif

template <class T>
class primarray {
  protected:
    T *v;
    int n, max;

    void reallocto(int newsize) {
      while (max<newsize) max += 16;
      char *x = new char[max*sizeof(T)];
      memcpy(x,v,n*sizeof(T));
      delete []((char *)v);
      v = (T *) x;
    }
  public:
    primarray() { v=NULL; n=max=0; }
    ~primarray() { setsize(0); delete []((char *)v); }

    int num() const { return n; }

    void setsize(int newsize) {
      if (newsize>max) reallocto(newsize);
      if (newsize>n) {
	// call default constructors
	//for (int i=n; i<newsize; i++) (void) new(&v[i]) T;
      }
      else {
	// call destructors
	//for (int i=newsize; i<n; i++) v[i].~T();
      }
      n = newsize;
    }

    T &operator [] (int ix) const {
      assert(ix>=0 && ix<n);
      return v[ix];
    }

    int add(const T &val) {
      int ix = n;
      setsize(n+1);
      v[ix] = val;
      return ix;
    }

    void push(const T &val) { add(val); }

    T pop() { T t = (*this)[n-1]; setsize(n-1); return t; }
};

#endif
