#include <assert.h>
#include "server.h"
#include "tile.h"
#include "rack.h"

void init_rack(rack *r) {
    for (int i=0; i<NTILES; i++) r->count[i] = 0;
}

int count_rack(const rack *r) {
    int ct=0;
    for (int i=0; i<NTILES; i++) ct += r->count[i];
    return ct;
}

void add_rack(rack *r, int tile) {
    int x = tile_name2num(tile);
    r->count[x]++;
}

void subtract_rack(rack *big, const rack *small) {
    for (int i=0; i<NTILES; i++) {
	big->count[i] -= small->count[i];
	assert(big->count[i]>=0);
    }
}

int subsetof_rack(const rack *haystack, const rack *needle) {
    for (int i=0; i<NTILES; i++) {
	if (haystack->count[i] < needle->count[i]) return 0;
    }
    return 1;
}

void spill_rack(const rack *r, char *buf) {
    int j=0;
    for (int i=0; i<NTILES; i++) {
	int ch = tile_num2name(i);
	for (int k=0; k<r->count[i]; k++) buf[j++] = ch;
    }
    buf[j] = 0;
}

int score_rack(const rack *r) {
    int score=0;
    for (int i=0; i<NTILES; i++) {
	score += r->count[i]*tilescore(tile_num2name(i));
    }
    return score;
}

