#include <string.h>
#include <stdlib.h>
#include <assert.h>

#include "server.h"
#include "rack.h"
#include "tileq.h"

static const rack alltiles = {{
    /* ABC  DEF  GHI */
    9, 2, 2, 4, 12, 2, 3, 2, 9, 
    /* JKL MNO PQR */
    1, 1, 4, 2, 6, 8, 2, 1, 6, 
    /* STU VWX YZ_ */
    4, 6, 4, 2, 2, 1, 2, 1, 2,
}};

tileq::tileq() {
    memset(tilequeue, 0, sizeof(tilequeue));
    tilequeuepos = 0;
    tilequeueempty=false;
}

int picktile(tileq *q) {
    int k = q->tilequeue[q->tilequeuepos];
    if (k>0) q->tilequeuepos++;
    return k;
}

static void randomize_tiles_using(tileq *q, const rack *somerack) {
    unsigned n = count_rack(somerack);
    char *tmp = new char[n+1];
    spill_rack(somerack, tmp);
    unsigned count = n;

    memset(q->tilequeue, 0, sizeof(q->tilequeue));
    q->tilequeuepos = 0;

    while (count>0) {
	int where = random()%n;
	if (tmp[where]) {
	    q->tilequeue[q->tilequeuepos++] = tmp[where];
	    tmp[where] = 0;
	    count--;
	}
    }

    assert(strlen(q->tilequeue)==n);
    q->tilequeuepos = 0;
}

void randomize_tiles(tileq *q) {
    randomize_tiles_using(q, &alltiles);
    q->tilequeueempty = false;
}

void return_tiles_to_queue(tileq *q, const rack *r) {
    rack rr(*r);
    int ch;
    while ((ch=picktile(q))!=0) {
	add_rack(&rr, ch);
    }
    randomize_tiles_using(q, &rr);
}

